// chrome/common/draggable_regions.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_COMMON_DRAGGABLE_REGIONS_MOJOM_H_
#define CHROME_COMMON_DRAGGABLE_REGIONS_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include <optional>
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "chrome/common/draggable_regions.mojom-features.h"
#include "chrome/common/draggable_regions.mojom-shared.h"
#include "chrome/common/draggable_regions.mojom-forward.h"
#include "ui/gfx/geometry/mojom/geometry.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"






namespace chrome::mojom {

class DraggableRegionsProxy;

template <typename ImplRefTraits>
class DraggableRegionsStub;

class DraggableRegionsRequestValidator;


class DraggableRegions
    : public DraggableRegionsInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = DraggableRegionsInterfaceBase;
  using Proxy_ = DraggableRegionsProxy;

  template <typename ImplRefTraits>
  using Stub_ = DraggableRegionsStub<ImplRefTraits>;

  using RequestValidator_ = DraggableRegionsRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kUpdateDraggableRegionsMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct UpdateDraggableRegions_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~DraggableRegions() = default;

  
  virtual void UpdateDraggableRegions(std::vector<DraggableRegionPtr> draggable_region) = 0;
};



class  DraggableRegionsProxy
    : public DraggableRegions {
 public:
  using InterfaceType = DraggableRegions;

  explicit DraggableRegionsProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void UpdateDraggableRegions(std::vector<DraggableRegionPtr> draggable_region) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  DraggableRegionsStubDispatch {
 public:
  static bool Accept(DraggableRegions* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      DraggableRegions* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<DraggableRegions>>
class DraggableRegionsStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  DraggableRegionsStub() = default;
  ~DraggableRegionsStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return DraggableRegionsStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return DraggableRegionsStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  DraggableRegionsRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};








class  DraggableRegion {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<DraggableRegion, T>::value>;
  using DataView = DraggableRegionDataView;
  using Data_ = internal::DraggableRegion_Data;

  template <typename... Args>
  static DraggableRegionPtr New(Args&&... args) {
    return DraggableRegionPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static DraggableRegionPtr From(const U& u) {
    return mojo::TypeConverter<DraggableRegionPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, DraggableRegion>::Convert(*this);
  }


  DraggableRegion();

  DraggableRegion(
      const ::gfx::Rect& bounds,
      bool draggable);


  ~DraggableRegion();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = DraggableRegionPtr>
  DraggableRegionPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, DraggableRegion::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, DraggableRegion::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, DraggableRegion::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        DraggableRegion::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        DraggableRegion::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::DraggableRegion_UnserializedMessageContext<
            UserType, DraggableRegion::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<DraggableRegion::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return DraggableRegion::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::DraggableRegion_UnserializedMessageContext<
            UserType, DraggableRegion::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<DraggableRegion::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::gfx::Rect bounds;
  
  bool draggable;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, DraggableRegion::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, DraggableRegion::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, DraggableRegion::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, DraggableRegion::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
DraggableRegionPtr DraggableRegion::Clone() const {
  return New(
      mojo::Clone(bounds),
      mojo::Clone(draggable)
  );
}

template <typename T, DraggableRegion::EnableIfSame<T>*>
bool DraggableRegion::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->bounds, other_struct.bounds))
    return false;
  if (!mojo::Equals(this->draggable, other_struct.draggable))
    return false;
  return true;
}

template <typename T, DraggableRegion::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.bounds < rhs.bounds)
    return true;
  if (rhs.bounds < lhs.bounds)
    return false;
  if (lhs.draggable < rhs.draggable)
    return true;
  if (rhs.draggable < lhs.draggable)
    return false;
  return false;
}


}  // chrome::mojom

namespace mojo {


template <>
struct  StructTraits<::chrome::mojom::DraggableRegion::DataView,
                                         ::chrome::mojom::DraggableRegionPtr> {
  static bool IsNull(const ::chrome::mojom::DraggableRegionPtr& input) { return !input; }
  static void SetToNull(::chrome::mojom::DraggableRegionPtr* output) { output->reset(); }

  static const decltype(::chrome::mojom::DraggableRegion::bounds)& bounds(
      const ::chrome::mojom::DraggableRegionPtr& input) {
    return input->bounds;
  }

  static decltype(::chrome::mojom::DraggableRegion::draggable) draggable(
      const ::chrome::mojom::DraggableRegionPtr& input) {
    return input->draggable;
  }

  static bool Read(::chrome::mojom::DraggableRegion::DataView input, ::chrome::mojom::DraggableRegionPtr* output);
};

}  // namespace mojo

#endif  // CHROME_COMMON_DRAGGABLE_REGIONS_MOJOM_H_